% Script che calcola e visualizza il polinomio di interpolazione 
% di un insieme di punti letti da file mediante: 
% 1. un unico polinomio nella forma di Newton
% 2. un polinomio a tratti cubici (spline cubiche).

% Legge i dati,
A=load('dataset1.dat');
[n m]=size(A);
x=A(1:n,1)';
y=A(1:n,2)';
a=min(x);
b=max(x);
n=length(x)-1  %Grado del polinomio interpolante

% punti di valutazione 
x1=[a:.01:b];
% Interpolazione di Newton
c=InterpN(x,y);
yInt=HornerN(c,x,x1); %valutazione del polinomio
% Interpolazione spline
yInt1=spline(x,y,x1);

%Visualizzazione polinomio e polinomio a tratti interpolante
subplot(2,1,1)
plot(x1,yInt,x,y,'ro')
legend('Interp. Newton','(x_i,y_i)')
subplot(2,1,2)
plot(x1,yInt1,x,y,'ro')
legend('Interp. spline','(x_i,y_i)')
